// fileio.c
//
//  The file io functions
//
//  October, 1998
//  jerry@mail.csh.rit.edu

#include <stdlib.h>

#include "allegro.h"
#include "general.h"
#include "drivsel.h"
#include "INIDriv.h"
#include "sprtplte.h"
#include "guipal.h"
#include "gamedesc.h"
#include "palette.h"
#include "editmode.h"
#include "sprite.h"


void unload_driver(void)
{
    FreeDriver();
    InitialiseGameDesc();
    free(sprite_bank);
    sprite_bank = NULL; 
    destroy_bitmap(current_sprite);
    current_sprite = create_bitmap(8,8);
    clear_to_color(current_sprite, FIRST_USER_COLOR);
}


void try_loading_the_driver(char * drivername)
{
    unload_driver();

    if (LoadDriver(drivername) == TRUE)
    {
	// setup the sprite palette & stuff..
	set_Gfx_bank(0);

	// load in the palette
	Init_Palette();
    } else {
	// we should do this here...
	/*
	FreeDriver();
	InitialiseGameDesc();
	free(sprite_bank);
	sprite_bank = NULL; 
	*/
	unload_driver();
    }
}


//
/// FILE MENU FUNCTIONS
//


// file_game  -  menu option
int file_game(void)
{
    if(GameDriverLoaded)
    {
	if (alert("ARE YOU SURE?", 
	          "You can't undo this!", 
	          "(even if we had an undo)", 
	      "Continue", "Cancel", 0, 0) == 2)
	      return D_O_K;
    }

    // unload the driver here...
    unload_driver();

    /*
    FreeDriver();
    InitialiseGameDesc();

    free(sprite_bank); // we should do this here...
    sprite_bank = NULL;
    */

    game_driver_selector();

    busy();

    if (strlen(selected_filename))
    {
	try_loading_the_driver(selected_filename);
	if(!GameDriverLoaded)
	{
	    not_busy();
	    alert("Error loading driver:", selected_filename, "Sorry.", 
	          "&Okay", NULL, 'O', 0);

	    unload_driver();
	}
    }

    not_busy();

    return D_REDRAW;
}

int file_revert(void)
{
    // re-load the data from the roms

    if(GameDriverLoaded)
    {
	if (alert("ARE YOU SURE?", 
	          "You can't undo this!", 
	          "(even if we had an undo)", 
	      "Continue", "Cancel", 0, 0) == 1)
	{
	    busy();
	    unload_driver();
	    //FreeDriver();

	    if (LoadDriver(INI_Driver_Path) == TRUE)
	    {
		// setup the sprite palette & stuff..
		set_Gfx_bank(0);

		// load in the palette
		Init_Palette();
	    }

	    not_busy();
	    return D_REDRAW;
	}

    } else {
	alert("Cannot revert graphics!", "No romdata loaded!", "Sorry.", 
	      "&Okay", NULL, 'O', 0);
    }

    return D_O_K;
}



int file_exit(void)
{
    // do check here:
    // if romset changed;
    //  ask user if they want to quit without saving
    return(D_EXIT);
}


int file_load_gfx(void)
{
   // um... not sure what this one is supposed to do... <shrug>

   return D_O_K;
}


int file_save_gfx(void)
{
    // save out the graphics data to the roms
    if (GameDriverLoaded)
    {
	busy();
	if (SaveDriver() == TRUE)
	{
	    not_busy();
	    alert("", "Save complete", NULL, "&Okay", NULL, 'O', 0);
	}
	not_busy();
    } else {
	alert("Cannot save graphics!", "No romdata loaded!", "Sorry.",
	"&Okay", NULL, 'O', 0);
    }

    return D_O_K;
}



int file_genpatch(void)
{
    // generate the patch file from the data changed...
    if(GameDriverLoaded)
    {
	busy();
	MakePatch();
	not_busy();
	alert("", "Patch generation complete", NULL, "&Okay", NULL, 'O', 0);

    } else {
	alert("Cannot generate patch!", "No romdata loaded!", "Sorry.",
	"&Okay", NULL, 'O', 0);
    }
    return D_O_K;
}


int file_applypatch(void)
{
    return D_O_K;
}
